<template>
  <v-card :is-empty="isEmpty" card-body-class="px-0">
    <template #empty> Please select the bus stop first </template>
    <h6 class="card-title mt-2 px-4">
      {{ title }}
    </h6>
    <v-table
      :items="scheduleTable"
      :headers="[{ title: 'Time', sortBy: 'miliseconds' }]"
    >
      <template #header>
        <th scope="col">Time</th>
      </template>
      <template #row="{ item: time }">
        <td>
          {{ time.time }}
        </td>
      </template>
    </v-table>
  </v-card>
</template>

<script setup lang="ts">
import VCard from '@/ui/v-card/VCard.vue';
import VTable from '@/ui/v-table/VTable.vue';

import { computed } from 'vue';

const props = defineProps<{
  schedule: string[];
  busStop?: string;
}>();

const title = computed(() => {
  return `Bus Stop: ${props.busStop}`;
});

const getMiliseconds = (time: string) => {
  const date = new Date();
  const [hours, minutes] = time.split(':');
  date.setHours(+hours, +minutes);
  return date.getTime();
};

const scheduleTable = computed(() => {
  return props.schedule
    .slice()
    .map((time) => {
      return {
        time,
        miliseconds: getMiliseconds(time),
      };
    })
    .sort((a, b) => a.miliseconds - b.miliseconds);
});

const isEmpty = computed(() => {
  return props.schedule.length === 0;
});
</script>

<style scoped></style>
